//
//  ViewController.m
//  蓝牙广播
//
//  Created by 李校松 on 16/8/11.
//  Copyright © 2016年 李校松. All rights reserved.
//

#import "ViewController.h"
#import <MultipeerConnectivity/MultipeerConnectivity.h>

@interface ViewController ()<MCSessionDelegate>
@property (weak, nonatomic) IBOutlet UIImageView *imageView;

@property (strong,nonatomic) MCSession *session;

@property (strong,nonatomic)  MCAdvertiserAssistant *assistant;
@end

@implementation ViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    //1.获取当前蓝牙设备并且显示在对方设备发现的名字,名字不能重复
    MCPeerID *peer = [[MCPeerID alloc]initWithDisplayName:@"蓝牙的名字"];
    //2.根据设备创建会话
    MCSession *session = [[MCSession alloc]initWithPeer:peer];
    //设置代理这样的话就可以接收从其他设备的传递的数据
    session.delegate = self;
    self.session = session;
    
    //.3创建广播助手
    MCAdvertiserAssistant *assistant = [[MCAdvertiserAssistant alloc]initWithServiceType:@"与发现的名字相同" discoveryInfo:nil session:session];
    self.assistant = assistant;
    //开始广播
    [assistant start];
    
    
    
    // Do any additional setup after loading the view, typically from a nib.
}
//控制器死了,停止广播
-(void)dealloc
{
    //停止广播
    [self.assistant stop];
}

// Remote peer changed state.远程对等改变状态。
- (void)session:(MCSession *)session peer:(MCPeerID *)peerID didChangeState:(MCSessionState)state
{
    switch (state) {
        case MCSessionStateConnecting:
            NSLog(@"正在建立连接");
            break;
        case MCSessionStateConnected:
            NSLog(@"成功建立连接");
            break;
        case MCSessionStateNotConnected:
            NSLog(@"断开连接");
            break;
        default:
            NSLog(@"异常情况");
            break;
    }
}

// Received data from remote peer.接收的数据从远程对等处理
- (void)session:(MCSession *)session didReceiveData:(NSData *)data fromPeer:(MCPeerID *)peerID
{
    NSLog(@"正在传输图片");
    UIImage *image = [UIImage imageWithData:data];
    
//    NSLog(@"%@",[NSThread currentThread]);
//    [[NSOperationQueue mainQueue]addOperationWithBlock:^{
//        self.imageView.image = image;
//    }];
    //对线程的判断
    if ([NSThread currentThread] != [NSThread mainThread]) {
        [[NSOperationQueue mainQueue]addOperationWithBlock:^{
            self.imageView.image = image;
        }];
    }else
    {
        self.imageView.image = image;
    }
}

// Received a byte stream from remote peer.接到远程对等的字节流。
- (void)    session:(MCSession *)session
   didReceiveStream:(NSInputStream *)stream
           withName:(NSString *)streamName
           fromPeer:(MCPeerID *)peerID
{
    
}

// Start receiving a resource from remote peer.开始接受从远程对等资源。
- (void)                    session:(MCSession *)session
  didStartReceivingResourceWithName:(NSString *)resourceName
                           fromPeer:(MCPeerID *)peerID
                       withProgress:(NSProgress *)progress
{
    
}

// Finished receiving a resource from remote peer and saved the content
// in a temporary location - the app is responsible for moving the file
// to a permanent location within its sandbox.
- (void)                    session:(MCSession *)session
 didFinishReceivingResourceWithName:(NSString *)resourceName
                           fromPeer:(MCPeerID *)peerID
                              atURL:(NSURL *)localURL
                          withError:(nullable NSError *)error
{
    
}




- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

@end
